/*
 * IsacOptionPane.java
 * gadei
 */

package isac.jedit



import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.gjt.sp.jedit.AbstractOptionPane;
import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.jedit.gui.FontSelector;

object IsacOptionPane {
  def makeFont(): Font ={
		var style = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontstyle"))
                var size = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontsize"))
		val family = jEdit.getProperty(IsacPlugin.OPTION_PREFIX
				+ "font"): String
		//size = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontsize"));#
		//style = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontstyle"));
		val ff = new java.awt.Font(family, style, size) : java.awt.Font

                ff
        }
  

}


class IsacOptionPane extends AbstractOptionPane("isac"){

	private var showPath = new JCheckBox()

	private var pathName = new JTextField()

	var isac_font = new FontSelector(makeFont())


	override def _init() {
		showPath = new JCheckBox(jEdit.getProperty(IsacPlugin.OPTION_PREFIX
						+ "show-filepath.title"), jEdit.getProperty(
				IsacPlugin.OPTION_PREFIX + "show-filepath").equals(
				"true"))
		addComponent(showPath)

		pathName = new JTextField(jEdit
				.getProperty(IsacPlugin.OPTION_PREFIX + "filepath"))

		val pickPath = new JButton(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "choose-file"))

		//pickPath.addActionListener(this)

		val pathPanel = new JPanel(new BorderLayout(0, 0))
		pathPanel.add(pathName, BorderLayout.CENTER)
		pathPanel.add(pickPath, BorderLayout.EAST)

		addComponent(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "file"), pathPanel)

		addComponent(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "choose-font"), isac_font)
	}

        def makeFont(): Font ={
		var style = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontstyle"))
                var size = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontsize"))
		val family = jEdit.getProperty(IsacPlugin.OPTION_PREFIX
				+ "font"): String
		//size = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontsize"));#
		//style = Integer.parseInt(jEdit.getProperty(IsacPlugin.OPTION_PREFIX + "fontstyle"));
		val ff = new java.awt.Font(family, style, size) : java.awt.Font

                ff
        }


	override def _save() {
		jEdit.setProperty(IsacPlugin.OPTION_PREFIX + "filepath",
				pathName.getText())
		val _font = isac_font.getFont()
		jEdit.setProperty(IsacPlugin.OPTION_PREFIX + "font", _font
				.getFamily())
		jEdit.setProperty(IsacPlugin.OPTION_PREFIX + "fontsize", String
				.valueOf(_font.getSize()))
		jEdit.setProperty(IsacPlugin.OPTION_PREFIX + "fontstyle",
				String.valueOf(_font.getStyle()))
		jEdit.setProperty(IsacPlugin.OPTION_PREFIX + "show-filepath",
				String.valueOf(showPath.isSelected()))
	}

	// end AbstractOptionPane implementation


	// helper method to get Font from plugin properties
	
}
