/*
 * IsacToolPanel.java
 * gadei
 */

package isac.jedit


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractButton;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.jedit.gui.RolloverButton;

class IsacToolPanel(var qnpad: Isac) extends JPanel {

  var pad = qnpad

        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
   

        val labelBox = new Box(BoxLayout.Y_AXIS): Box
        labelBox.add(Box.createGlue())

        var label = new JLabel(Isac.getFilename())
        label.setVisible(jEdit.getProperty(
                        IsacPlugin.OPTION_PREFIX + "show-filepath").equals(
                        "true"))

        labelBox.add(label)
        labelBox.add(Box.createGlue())

        add(labelBox)

        add(Box.createGlue())
/*
        add(makeCustomButton("isac.choose-file", new ActionListener() {
               def actionPerformed(evt: ActionEvent) {
                        IsacToolPanel.this.pad.chooseFile()
        }))

        
        add(makeCustomButton("isac.save-file", new ActionListener() {
              /*
                public void actionPerformed(ActionEvent evt) {
                        IsacToolPanel.this.pad.saveFile()
                }
                */
        }))

        add(makeCustomButton("isac.copy-to-buffer", new ActionListener() {
              /*
                                public void actionPerformed(ActionEvent evt) {
                                        IsacToolPanel.this.pad.copyToBuffer()
                                }
                */
        }))

*/
	def propertiesChanged() {
		label.setText(pad.getFilename());
		label.setVisible(jEdit.getProperty(
				IsacPlugin.OPTION_PREFIX + "show-filepath").equals(
				"true"))
	}

	def makeCustomButton(name: String, listener: ActionListener){
		val toolTip = jEdit.getProperty(name.concat(".label")): String
		val b = new RolloverButton(GUIUtilities.loadIcon(jEdit.getProperty(name + ".icon"))): AbstractButton

		if (listener != null) {
			b.addActionListener(listener);
			b.setEnabled(true);
		} else {
			b.setEnabled(false);
		}
                
               b.setToolTipText(toolTip)
		
	}

}
